package com.eladit.hb9eik.blueduo;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.Typeface;
import android.os.Handler;
import android.util.AttributeSet;
import android.util.Log;
import android.util.TypedValue;
import android.view.MotionEvent;
import android.view.View;
import android.widget.AbsoluteLayout;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

import java.io.IOException;
import java.io.OutputStream;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

public class myButton implements View.OnTouchListener{
    static private int maxrow=8;
    static private int maxcol=15;
    private int top;
    private int left;
    private int height;
    private int width;
    private int textSize;
    private MainActivity app;
    private String name;
    private Button bt;
    private int resultSettings;
    private ArrayList<myButton> numeri;
    private ArrayList<myButton> normali;
    private plot slider=null;

    myButton(Context context, AbsoluteLayout al, int screenHeight, int screenWidth, int id, String name, int row, int col, int color, MainActivity app, boolean enabled  ){
        bt = new Button(context);
        bt.setId( id );
        bt.setText( name );
        width=screenWidth/maxcol;
        height=screenHeight/maxrow;
        left=screenWidth*col/maxcol;
        top=screenHeight*row/maxrow;
        bt.setPadding(0,0,0,0);
        bt.setIncludeFontPadding(false);
        textSize=14*screenWidth/800;
        bt.setTextSize(TypedValue.COMPLEX_UNIT_PX,textSize);
        bt.setTypeface(null,Typeface.BOLD);
        bt.setTextColor(color);
        this.app=app;
        this.name=name;
        al.addView(bt, new AbsoluteLayout.LayoutParams(width, height, left, top));
        al.refreshDrawableState();
        bt.setOnTouchListener(this);
        if( enabled ) {
            bt.setVisibility(View.VISIBLE);
        } else {
            bt.setVisibility(View.INVISIBLE);
        }
    }

    public void setVisibility(int visibility){
        bt.setVisibility( visibility );
    }
    public Button getBt( ) { return bt; }
    public MainActivity getApp( ) { return app; }

    public boolean onTouch(View v, MotionEvent event) {
        switch (event.getAction()) {
            case MotionEvent.ACTION_DOWN:
                if(  name.equals("NB") ) {
                    NBdown();
                } else if( name.equals("NR") ) {
                    NRdown();
                } else if( name.equals("AN") ) {
                    ANdown();
                } else if( name.equals("AGC") ) {
                    AGCdown();
                } else if( name.equals("MGC") ) {
                    MGCdown();
                } else if( name.equals("Thr") ) {
                    Thrdown();
                } else if( name.equals("RIT") ) {
                    RITdown();
                } else if( name.equals("SQ") ) {
                    SQdown();
                } else if( name.equals("BW") ) {
                    BWdown();
                } else if( name.equals("MUTE") ) {
                    MUTEdown();
                } else if( name.equals("CW-") ) {
                    CWMdown();
                } else if( name.equals("CW+") ) {
                    CWPdown();
                } else if( name.equals("LSB") ) {
                    LSBdown();
                } else if( name.equals("USB") ) {
                    USBdown();
                } else if( name.equals("AM") ) {
                    AMdown();
                } else if( name.equals("FM") ) {
                    FMdown();
                } else if( name.equals("PTT") ) {
                    PTTdown();
                } else if( name.equals("TUNE") ) {
                    TUNEdown();
                } else if( name.equals("160m") ) {
                    BANDset("160m");
                } else if( name.equals("80m") ) {
                    BANDset("80m");
                } else if( name.equals("40m") ) {
                    BANDset("40m");
                } else if( name.equals("30m") ) {
                    BANDset("30m");
                } else if( name.equals("20m") ) {
                    BANDset("20m");
                } else if( name.equals("17m") ) {
                    BANDset("17m");
                } else if( name.equals("15m") ) {
                    BANDset("15m");
                } else if( name.equals("12m") ) {
                    BANDset("12m");
                } else if( name.equals("10m") ) {
                    BANDset("10m");
                } else if( name.equals("6m") ) {
                    BANDset("6m");
                } else if( name.equals("2m") ) {
                    BANDset("2m");
                } else if( name.equals("Att") ) {
                    AttDown();
                } else if( name.equals("LP") ) {
                    LpDown();
                } else if( name.equals("Del") ) {
                    if( app.getNewFreq().length() > 0 ) {
                        app.setNewFreq(app.getNewFreq().substring(0, app.getNewFreq().length() - 1));
                        app.getNewFreqLabel().setText( "New Frequency: "+app.getFreqFormat().format(Integer.parseInt(app.getNewFreq() ) ) );
                    }
                } else if( name.equals("Abort") ) {
                    disableNumbers();
                } else if( name.equals("1") || name.equals("2") || name.equals("3") || name.equals("4") || name.equals("5") || name.equals("6") || name.equals("7") || name.equals("8") || name.equals("9") || name.equals("0") ) {
                    app.setNewFreq(app.getNewFreq()+name);
                    app.getNewFreqLabel().setText( "New Frequency: "+app.getFreqFormat().format(Integer.parseInt(app.getNewFreq() ) ) );
                } else if( name.equals("MHz") ) {
                    try {
                        int freq = Integer.parseInt(app.getNewFreq()+"000000");
                        if( freq > 60000000 ) {
                            to2m();
                        } else if( app.getFreq() > 60000000 ) {
                            from2m();
                        }
                        app.setFreq( freq, null ,null );
                    } catch(NumberFormatException nfe) {}
                    disableNumbers();
                } else if( name.equals("KHz") ) {
                    try {
                        int freq = Integer.parseInt(app.getNewFreq()+"000");
                        if( freq > 60000000 ) {
                            to2m();
                        } else if( app.getFreq() > 60000000 ) {
                            from2m();
                        }
                        app.setFreq( freq, null ,null );
                    } catch(NumberFormatException nfe) {}
                    disableNumbers();
                } else if( name.equals("Hz") ) {
                    try {
                        int freq = Integer.parseInt(app.getNewFreq());
                        if( freq > 60000000 ) {
                            to2m();
                        } else if( app.getFreq() > 60000000 ) {
                            from2m();
                        }
                        app.setFreq( freq, null ,null );
                    } catch(NumberFormatException nfe) {}
                    disableNumbers();
                }
                break;
            case MotionEvent.ACTION_UP:
                if(  name.equals("NB") ) {
                    NBup();
                } else if( name.equals("NR") ) {
                    NRup();
                } else if( name.equals("AN") ) {
                    ANup();
                } else if( name.equals("AGC") ) {
                    AGCup();
                } else if( name.equals("MGC") ) {
                    MGCup();
                } else if( name.equals("Thr") ) {
                    Thrup();
                } else if( name.equals("RIT") ) {
                    RITup();
                } else if( name.equals("SQ") ) {
                    SQup();
                } else if( name.equals("BW") ) {
                    BWup();
                }
                break;
        }
        return false;
    }
    public void disableNumbers() {
        app.getNewFreqLabel().setVisibility(View.INVISIBLE);
        app.getFreqLabel().setVisibility(View.VISIBLE);
        myButton bt;
        numeri=app.getNumeri();
        normali=app.getNormali();
        app.setNewFreq("");
        for( int j=0; j<numeri.size(); j++ ) {
            bt = numeri.get(j);
            bt.setVisibility(View.INVISIBLE);
        }
        for( int j=0; j<normali.size(); j++ ) {
            bt = normali.get(j);
            bt.setVisibility(View.VISIBLE);
        }
    }
    public void AlertBox(Context context, String title, String message ){
        new AlertDialog.Builder(context)
                .setTitle( title )
                .setMessage( message + "\nPress OK to dismiss." )
                .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface arg0, int arg1) {  }
                }).show();
    }
    void NBdown(){
        String catCmd;
        int nb=app.getNb();
        if( nb>0 ) {
            catCmd="NK0000;";
        } else {
            catCmd="NK0"+String.format("%03d",-nb)+";";
        }
        // app.setNb(-nb);
        catCmd+="GM026;";
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        if( myState[21] == 0x30 ){
            myState[21]=0x32;
        } else {
            myState[21]=0x30;
        }
        int width=app.getScreenWidth()*4/15;
        int height=app.getScreenHeight()*1/8;
        int left=this.left+this.width/2-width*(nb>0?nb:-nb)/11;
        if( left<5) { left = 5; }
        int top=app.getScreenHeight()*12/16;
        app.getSl().setLayoutParams( new AbsoluteLayout.LayoutParams(width, height, left, top));
        app.getSl().setVisibility(View.VISIBLE);
        app.getSl().bringToFront();
        app.getSlider().NewData(nb>0?nb:-nb,10,this,"NK0%03d;", 0, null );
        bt.setOnTouchListener(app.getSlider());
        app.getSl().refreshDrawableState();
    }
    void NBup(){
        String catCmd="GM020;";
        sendCmd( catCmd );
        catCmd="GM000;";
        sendCmd( catCmd );
        app.getSl().setVisibility(View.INVISIBLE);
        app.getSl().refreshDrawableState();
        bt.setOnTouchListener(this);
        bt.refreshDrawableState();
    }
    void NRdown(){
        String catCmd;
        int nr=app.getNr();
        if( nr>0 ) {
            catCmd="NC0000;";
        } else {
            catCmd="NC0"+String.format("%03d",-nr)+";";
        }
        // app.setNr(-nr);
        catCmd+="GM025;";
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        if( myState[20] == 0x30 ){
            myState[20]=0x31;
        } else {
            myState[20]=0x30;
        }
        int width=app.getScreenWidth()*4/15;
        int height=app.getScreenHeight()*1/8;
        int left=this.left+this.width/2-width*(nr>0?nr:-nr)/11;
        int top=app.getScreenHeight()*12/16;
        app.getSl().setLayoutParams( new AbsoluteLayout.LayoutParams(width, height, left, top));
        app.getSl().setVisibility(View.VISIBLE);
        app.getSl().bringToFront();
        app.getSlider().NewData(nr>0?nr:-nr,10,this,"NC0%03d;", 0, null );
        bt.setOnTouchListener(app.getSlider());
        app.getSl().refreshDrawableState();
    }
    void NRup(){
        String catCmd="GM020;";
        sendCmd( catCmd );
        catCmd="GM000;";
        sendCmd( catCmd );
        app.getSl().setVisibility(View.INVISIBLE);
        app.getSl().refreshDrawableState();
        bt.setOnTouchListener(this);
        bt.refreshDrawableState();
    }
    void ANdown(){
        String catCmd;
        int an=app.getAn();
        if( an>0 ) {
            catCmd="NO0000;";
        } else {
            catCmd="NO0"+String.format("%03d",-an)+";";
        }
        // app.setAn(-an);
        catCmd+="GM027;";
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        if( (myState[26] & 0x06) == 0x00 ){
            myState[26] |= (byte) 0x02;
        } else {
            myState[26] &= (byte) 0xF9;
        }
        int width=app.getScreenWidth()*1/15;
        int height=app.getScreenHeight()*1/8;
        int left=this.left+this.width/2-width*(an>0?an:-an)/3;
        int top=app.getScreenHeight()*12/16;
        app.getSl().setLayoutParams( new AbsoluteLayout.LayoutParams(width, height, left, top));
        app.getSl().setVisibility(View.VISIBLE);
        app.getSl().bringToFront();
        app.getSlider().NewData(an>0?an:-an,2,this,"NO0%03d;", 0, null );
        bt.setOnTouchListener(app.getSlider());
        app.getSl().refreshDrawableState();
    }
    void ANup(){
        String catCmd="GM020;GM000;";
        sendCmd( catCmd );
        app.getSl().setVisibility(View.INVISIBLE);
        app.getSl().refreshDrawableState();
        bt.setOnTouchListener(this);
        bt.refreshDrawableState();
    }
    void AGCdown(){
        String catCmd;
        int agc=app.getAgc();
        catCmd="GC0;GM023;";
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        myState[18] &= (byte) 0xFB;
        int width=app.getScreenWidth()*2/15;
        int height=app.getScreenHeight()*1/8;
        int left=this.left+this.width/2-width*(agc>0?agc:-agc)/4;
        int top=app.getScreenHeight()*12/16;
        app.getSl().setLayoutParams( new AbsoluteLayout.LayoutParams(width, height, left, top));
        app.getSl().setVisibility(View.VISIBLE);
        app.getSl().bringToFront();
        String[] labels={ "Slo", "Med", "Fst" };
        app.getSlider().NewData(agc>0?agc:-agc,3,this,"GS0%03d;", -1, labels );
        bt.setOnTouchListener(app.getSlider());
        app.getSl().refreshDrawableState();
    }
    void AGCup(){
        String catCmd="GM020;GM000;";
        sendCmd( catCmd );
        app.getSl().setVisibility(View.INVISIBLE);
        app.getSl().refreshDrawableState();
        bt.setOnTouchListener(this);
        bt.refreshDrawableState();
    }
    void MGCdown(){
        String catCmd;
        int mgc=app.getMgc();
        catCmd="GC1;GM024;";
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        myState[18] |= (byte) 0x04;
        int width=app.getScreenWidth()*4/15;
        int height=app.getScreenHeight()*1/8;
        int left=this.left+this.width/2-width*(mgc>0?mgc:-mgc)/11;
        int top=app.getScreenHeight()*12/16;
        app.getSl().setLayoutParams( new AbsoluteLayout.LayoutParams(width, height, left, top));
        app.getSl().setVisibility(View.VISIBLE);
        app.getSl().bringToFront();
        app.getSlider().NewData(mgc>0?mgc:-mgc,10,this,"GS1%03d;", 0, null );
        bt.setOnTouchListener(app.getSlider());
        app.getSl().refreshDrawableState();
    }
    void MGCup(){
        String catCmd="GM020;GM000;";
        sendCmd( catCmd );
        app.getSl().setVisibility(View.INVISIBLE);
        app.getSl().refreshDrawableState();
        bt.setOnTouchListener(this);
        bt.refreshDrawableState();
    }
    void Thrdown(){
        String catCmd;
        int thr=app.getThr();
        catCmd="GC0;GM028;";
        sendCmd( catCmd );
        int width=app.getScreenWidth()*4/15;
        int height=app.getScreenHeight()*1/8;
        int left=this.left+this.width/2-width*(thr>0?thr:-thr)/11;
        int top=app.getScreenHeight()*12/16;
        app.getSl().setLayoutParams( new AbsoluteLayout.LayoutParams(width, height, left, top));
        app.getSl().setVisibility(View.VISIBLE);
        app.getSl().bringToFront();
        app.getSlider().NewData(thr>0?thr:-thr,10,this,"TH%02d;", 0, null );
        bt.setOnTouchListener(app.getSlider());
        app.getSl().refreshDrawableState();

        }
    void Thrup(){
        String catCmd="GM020;GM000;";
        sendCmd( catCmd );
        app.getSl().setVisibility(View.INVISIBLE);
        app.getSl().refreshDrawableState();
        bt.refreshDrawableState();
    }
    void RITdown(){
        String catCmd;
        int rit=app.getRit();
        if( rit>0 ) {
            catCmd="RT0;";
            app.setRit( 0 );
        } else {
            catCmd="RT1;";
            app.setRit( 1 );
        }
        // app.setRit(-rit);
        catCmd+="GM063;";
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        if( (myState[26] & 0x01) == 0x01 ){
            myState[26] &= (byte) 0xFE;
            myState[32]=0x30; // RIT
            myState[33]=0x30; // RIT
            myState[34]=0x30; // RIT
            myState[35]=0x30; // RIT
            myState[36]=0x30; // RIT
        } else {
            myState[26] |= (byte) 0x01;
            myState[32]=0x30; // RIT (1000)
            myState[33]=0x30; // RIT
            myState[34]=0x33; // RIT
            myState[35]=0x3E; // RIT
            myState[36]=0x38; // RIT
        }
    }
    void RITup(){
        String catCmd="GM060;";
        sendCmd( catCmd );
        catCmd="GM000;";
        sendCmd( catCmd );
    }
    void SQdown(){
        String catCmd;
        int sq=app.getSq();
        if( sq>0 ) {
            catCmd="SQ0000;";
        } else {
            catCmd="SQ0"+String.format("%03d",-sq)+";";
        }
        byte[] myState = app.getMyState();
        if( myState[17] == 0x40 ){
            myState[17]=0x45;
        } else {
            myState[17]=0x40;
        }
        int width=app.getScreenWidth()*4/15;
        int height=app.getScreenHeight()*1/8;
        int left=this.left+this.width/2-width*(sq>0?sq:-sq)/11;
        int top=app.getScreenHeight()*12/16;
        app.getSl().setLayoutParams( new AbsoluteLayout.LayoutParams(width, height, left, top));
        app.getSl().setVisibility(View.VISIBLE);
        app.getSl().bringToFront();
        app.getSlider().NewData(sq>0?sq:-sq,10,this,"SQ0%03d;", 0, null );
        bt.setOnTouchListener(app.getSlider());
        app.getSl().refreshDrawableState();
        catCmd+="GM021;";
        sendCmd( catCmd );
    }
    void SQup(){
        String catCmd="GM020;";
        sendCmd( catCmd );
        catCmd="GM000;";
        sendCmd( catCmd );
        app.getSl().setVisibility(View.INVISIBLE);
        bt.setOnTouchListener(this);
        app.getSl().refreshDrawableState();
    }
    void BWdown(){
        int bw=app.getBw();
        int bwl=app.getBwl();
        int bws=app.getBws();
        int width=app.getScreenWidth()*4/15;
        int height=app.getScreenHeight()*1/8;
        int left=this.left+this.width/2-width*bw/(bwl+1);
        int top=app.getScreenHeight()*12/16;
        app.getSl().setLayoutParams( new AbsoluteLayout.LayoutParams(width, height, left, top));
        app.getSl().setVisibility(View.VISIBLE);
        app.getSl().bringToFront();
        int mode=app.getMod();
        String[] arr1={"2.5","3.0","3.5","4.0","4.5","5.0","5.5","6.0"};
        String[] arr2={"1.6","","1.8","","2.0","","2.2","","2.4","","2.6","","2.8","","3.0","","4.0","","6.0","","D6",""};
        String[] arr4={"&4","&3","&2","&1",".1",".3",".5","1.0","1.5","2.6"};
        String[] arr5={"Narrow","Wide","Data"};
        switch( mode ) {
            case 1:
                app.getSlider().NewData(bw,bwl,this,"RF5%02d;", -1, arr1 );
                break;
            case 2:
                app.getSlider().NewData(bw,bwl,this,"RF1%02d;", -1, arr2 );
                break;
            case 3:
                app.getSlider().NewData(bw,bwl,this,"RF2%02d;", -1, arr2 );
                break;
            case 4:
                app.getSlider().NewData(bw,bwl,this,"RF3%02d;",  6, arr4 );
                break;
            case 5:
                app.getSlider().NewData(bw,bwl,this,"RF4%02d;", -1, arr5 );
                break;
            case 6:
                app.getSlider().NewData(bw,bwl,this,"RF3%02d;",  6, arr4 );
                break;

        }
        bt.setOnTouchListener(app.getSlider());
        app.getSl().refreshDrawableState();
        String catCmd="GM060;";
        sendCmd( catCmd );
    }
    void BWup(){
        String catCmd="GM020;GM000;";
        sendCmd( catCmd );
        app.getSl().setVisibility(View.INVISIBLE);
        bt.setOnTouchListener(this);
        app.getSl().refreshDrawableState();
    }
    void MUTEdown(){
        String catCmd;
        int volume=app.getVolume();
        if( volume>0 ) {
            catCmd="VM000;";
        } else {
            catCmd="VM"+String.format("%03d",-volume)+";";
        }
        // app.setVolume(-volume);
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        if( (myState[16] & 0x08) == 0x08 ) {
            myState[16] &= 0xF7;
            myState[28] = (byte)0x80;
        } else {
            myState[16] |= 0x08;
            myState[28] = (byte)0xB2;
        }
    }
    void AttDown(){
        int att=app.getAtt();
        String catCmd;
        if( att>0 ) {
            catCmd="AT0;";
        } else {
            catCmd="AT1;";
        }
        // app.setAtt(-att);
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        if( (myState[26] & 0x10) == 0x10 ){
            myState[26] &= (byte) 0xEF;
        } else {
            myState[26] |= (byte) 0x10;
        }
    }
    void LpDown(){
        int lp=app.getLp();
        String catCmd;
        if( lp>0 ) {
            catCmd="LP0;";
        } else {
            catCmd="LP1;";
        }
        // app.setLp(-lp);
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        if( (myState[26] & 0x08) == 0x08 ){
            myState[26] &= (byte) 0xF7;
        } else {
            myState[26] |= (byte) 0x08;
        }
    }
    void CWMdown(){
        String catCmd="MD7;";
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        myState[15]=0x16;
    }
    void CWPdown(){
        String catCmd="MD3;";
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        myState[15]=0x14;
    }
    void LSBdown(){
        String catCmd="MD1;";
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        myState[15]=0x12;
    }
    void USBdown(){
        String catCmd="MD2;";
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        myState[15]=0x13;
    }
    void AMdown(){
        String catCmd="MD5;";
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        myState[15]=0x11;
    }
    void FMdown(){
        String catCmd="MD4;";
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        myState[15]=0x15;
    }
    void PTTdown(){
        int ptt=app.getPtt();
        int tune=app.getTune();
        String catCmd;
        if( ptt>0 || tune>0 ) {
            catCmd="RX;";
        } else {
            catCmd="TX0;";
        }
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        if( (myState[15] & 0x40) == 0x40 || (myState[16] & 0x01) == 0x01 ) {
            myState[16] &= 0xFE;
            myState[15] &= 0xBF;
        } else {
            myState[15] |= 0x40;
        }
    }
    void TUNEdown(){
        int tune=app.getTune();
        int ptt=app.getPtt();
        String catCmd;
        if(tune>0 || ptt>0 ) {
            catCmd="RX;";
        } else {
            catCmd="TX2;";
        }
        sendCmd( catCmd );
        byte[] myState = app.getMyState();
        if( (myState[15] & 0x40) == 0x40 || (myState[16] & 0x01) == 0x01 ) {
            myState[16] &= 0xFE;
            myState[15] &= 0xBF;
        } else {
            myState[15] |= 0x40;
        }
    }
    void to2m() {
        String catCmd;
        catCmd="TT1;LP0;";
        sendCmd( catCmd );
    }
    void from2m() {
        String catCmd;
        catCmd="TT0;LP1;";
        sendCmd( catCmd );
    }
    void BANDset( String bandname ) {
        List<band> bands=app.getBands();
        band to=null;
        for( int j=0; j<bands.size(); j++ ) {
            band ba = bands.get(j);
            if (bandname.equals(ba.getName())) {
                to = ba;
            }
            if (to != null) {
                break;
            }
        }
        if( to != null ){
            if(bandname.equals("2m")){
                to2m();
            }
            app.setFreq(to.getFreq(),to,this);
        }
    }
    void sendCmd(String catCmd ) {
        try {
            OutputStream outS=app.getOutStream();
            if( outS !=null ) {
                outS.write(catCmd.getBytes());
                outS.flush();
            }
        } catch (IOException e) {
            AlertBox(app, "Error", "Serial cat send error\n" + catCmd + "\n" + e.toString());
        }
    }

}
