package com.eladit.hb9eik.blueduo;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;

import java.lang.reflect.Method;

public class slider extends View implements View.OnTouchListener {

    private int height, width;
    private int s,d, f;
    private String[] label;
    private myButton bt;
    private plot2d pl;
    private Paint paint;
    private String send;
    private int mode;
    private int sign;
    private int offset;
    private int top;

    public slider(Context context, int height, int width) {
        super(context);
        this.height=height;
        this.width=width;
        s=0;
        d=0;
        f=0;
        paint = new Paint();
    }
    protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
        width = MeasureSpec.getSize(widthMeasureSpec);
        height = MeasureSpec.getSize(heightMeasureSpec);
        this.setMeasuredDimension( width, height );
        super.onMeasure(widthMeasureSpec, heightMeasureSpec);
    }
    protected void onDraw(Canvas canvas) {
        paint.setStrokeWidth(1);
        canvas.drawARGB(255, 0, 0, 0);
        // height=canvas.getHeight();
        // width=canvas.getWidth();
        paint.setColor(Color.argb(255, 0x0, 0x0, 0x85));
        for(int j = 0;j<height;j++) {
            canvas.drawLine(0,j,width,j,paint);
        }
        if( mode == 1) {
            for (int j = 0; j < (d + 2); j++) {
                paint.setTextAlign(Paint.Align.CENTER);
                paint.setTextSize(12.0f);
                //assi verticali:
                paint.setColor(Color.YELLOW);
                canvas.drawLine(0, 0, 0, height - 1, paint);
                canvas.drawLine(width - 1, 0, width - 1, height - 1, paint);
                if (j != 0 && j != (d + 1)) {
                    canvas.drawLine(width * j / (d + 1), 0, width * j / (d + 1), height / 2 + 4, paint);
                    String temp = Integer.toString(j*sign+offset);
                    if (label != null) {
                        temp = label[j - 1];
                    }
                    canvas.drawText(temp, width * j / (d + 1), height / 2 + 16, paint);
                } else {
                    canvas.drawLine(width * j / (d + 1), 0, width * j / (d + 1), height / 2, paint);
                }
            }
            canvas.drawLine(0,height/2-1,width,height/2-1,paint);
            canvas.drawLine(0,0,width,0,paint);
            canvas.drawLine(0,height-1,width,height-1,paint);
            canvas.drawLine(width-1,0,width-1,height/2-1,paint);
            if( s>0 ) {
                paint.setColor(Color.RED);
                canvas.drawLine(width * s / (d+1), 0, width * s / (d+1), height-1, paint);
            }
        } else {
            for (int j = 0; j < (d + 2); j++) {
                paint.setTextAlign(Paint.Align.CENTER);
                paint.setTextSize(12.0f);
                //assi orizzontali:
                paint.setColor(Color.YELLOW);
                canvas.drawLine(1, 0, 1, height - 1, paint);
                canvas.drawLine(width - 1, 0, width - 1, height - 1, paint);
                if (j != 0 && j != (d + 1)) {
                    canvas.drawLine(width / 2, height * j / (d + 1), width, height * j / (d + 1), paint);
                    String temp = Integer.toString(j*sign+offset);
                    if (label != null) {
                        temp = label[j - 1];
                    }
                    canvas.drawText(temp, width / 4, height * j / (d + 1), paint);
                } else {
                    canvas.drawLine(1, height * j / (d + 1), width, height * j / (d + 1), paint);
                }
                canvas.drawLine(width / 2 - 1, 0, width / 2 - 1, height, paint);
                canvas.drawLine(1,0,width,0,paint);
                canvas.drawLine(1,height-1,width,height-1,paint);
                canvas.drawLine(width-1,0,width-1,height/2-1,paint);
                if( s>0 ) {
                    paint.setColor(Color.RED);
                    canvas.drawLine(width/2, height * s / (d+1), width, height * s / (d+1), paint);
                }
            }
        }
    }
    public void NewData( int s, int d, myButton bt, String send, int f, String[] label ) {
        this.s=s;
        this.d=d;
        this.f=f;
        this.bt=bt;
        this.pl=null;
        this.label=label;
        this.send=send;
        this.mode=1;
        this.sign=1;
        invalidate();
    }

    public void NewData( int s, int d, plot2d pl, String send, int fi, int sign, int offset, int top ) {
        this.s=s;
        this.d=d;
        this.f=f;
        this.bt=null;
        this.pl=pl;
        this.label=null;
        this.send=send;
        this.mode=0;
        this.sign=sign;
        this.offset=offset;
        this.top=top;
        invalidate();
    }

    @Override

    public boolean onTouch(View v, MotionEvent event) {

        switch (event.getAction()) {
            case MotionEvent.ACTION_MOVE:
                if( mode == 1 ) {
                    float x = event.getX() - bt.getApp().getSl().getLeft() + bt.getBt().getLeft();
                    int c = (int) ((d + 1) * x / (bt.getApp().getSl().getWidth()));
                    if (event.getY() < (int) 0 && c > 0 && c < d + 1) {
                        this.s = c;
                        if (send != null) {
                            bt.sendCmd(String.format(this.send, this.s + this.f));
                        }
                        invalidate();
                    }
                    c = 0;
                } else {
                    float y = event.getY() - this.top;
                    int c = (int) ((d + 1) * y / height);
                    this.s = c;
                    if( send.equals("level" ) ) {
                        pl.level(c*sign+offset);
                    }
                    if( send.equals("delta" ) ) {
                        pl.delta(c*sign+offset);
                    }
                    pl.invalidate();
                    invalidate();
                c = 0;
                }
                break;
            case MotionEvent.ACTION_DOWN:
               break;
            case MotionEvent.ACTION_UP:
                if( bt != null ) {
                    event.setAction(MotionEvent.ACTION_UP);
                    bt.onTouch(bt.getApp().getSl(), event);
                    bt.getBt().setOnTouchListener(bt);
                    return false;
                }
                if( pl != null ) {
                    event.setAction(MotionEvent.ACTION_UP);
                    pl.onTouch(pl, event);
                    pl.setOnTouchListener(pl);
                    return false;
                }
                break;
        }
        //invalidate();
        return true;
    }


}
